/*
 * aMazeGUI.java
 *
 * Created on June 20, 2007, 7:32 PM
 */

package gui;

import amazeproject.*;

/**
 * Maze Application GUI Class
 * @author  Tomasz Gebarowski
 */
public class aMazeGUI extends javax.swing.JFrame {
    
    /** Creates new form aMazeGUI */
    public aMazeGUI() {
        initComponents();
        bSolve.setEnabled(false);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jPanel1 = new javax.swing.JPanel();
        bGenerate = new javax.swing.JButton();
        bSolve = new javax.swing.JButton();
        jComboBox1 = new javax.swing.JComboBox();
        jLabel1 = new javax.swing.JLabel();
        maze = new Maze();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        bGenerate.setText("Generate");
        bGenerate.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bGenerateActionPerformed(evt);
            }
        });

        bSolve.setText("Solve");
        bSolve.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bSolveActionPerformed(evt);
            }
        });

        jComboBox1.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "10 x 10", "15 x 15", "20 x 20", "25 x 25", "30 x 30", "5 x 5", "8 x 8" }));

        jLabel1.setText("Dimensions");

        org.jdesktop.layout.GroupLayout jPanel1Layout = new org.jdesktop.layout.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1Layout.createSequentialGroup()
                .add(jLabel1)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jComboBox1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 155, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(bGenerate)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(bSolve)
                .addContainerGap(152, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel1)
                    .add(jComboBox1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(bGenerate)
                    .add(bSolve))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        org.jdesktop.layout.GroupLayout mazeLayout = new org.jdesktop.layout.GroupLayout(maze);
        maze.setLayout(mazeLayout);
        mazeLayout.setHorizontalGroup(
            mazeLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 557, Short.MAX_VALUE)
        );
        mazeLayout.setVerticalGroup(
            mazeLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 347, Short.MAX_VALUE)
        );

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .add(maze, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(jPanel1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(maze, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        pack();
    }// </editor-fold>//GEN-END:initComponents

    /** Solve button action handler */
    private void bSolveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bSolveActionPerformed

        maze.solve(this);
        
    }//GEN-LAST:event_bSolveActionPerformed

    /** Generate button action handler **/
    private void bGenerateActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bGenerateActionPerformed
        
        int index = jComboBox1.getSelectedIndex();
        
        switch ( index ) {
            
            case 0: maze.init(10, 10); maze.generate(); break;
            case 1: maze.init(15, 15);maze.generate(); break;
            case 2: maze.init(20, 20);maze.generate(); break;
            case 3: maze.init(25, 25);maze.generate(); break;
            case 4: maze.init(30, 30);maze.generate(); break;
            case 5: maze.init(5, 5);maze.generate(); break;
            case 6: maze.init(8, 8);maze.generate(); break;
            
            default: maze.init(15, 15); maze.generate();
        }
        bSolve.setEnabled(true);
    }//GEN-LAST:event_bGenerateActionPerformed
    
    /** Disables solve button */
    public void disableSolveButton() {
        this.bSolve.setEnabled(false);
    }
    
 
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton bGenerate;
    private javax.swing.JButton bSolve;
    private javax.swing.JComboBox jComboBox1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JPanel jPanel1;
    private Maze maze;
    // End of variables declaration//GEN-END:variables
    
}
